//
// Created by robtor on 09.12.22.
//

#ifndef FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H
#define FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H

#include "Menu_Entry_Type_Delegate.h"

namespace floatpump {
    namespace menu {

    class Menu_Entry_Type_Checkable : public Menu_Entry_Type_Delegate<bool> {
    public:
        std::string toString() override {
            return std::string("E: " + m_name);
        }

        void u_press() override {
            Menu_Entry_Type_Delegate::u_press();
        }

        void u_increase(uint16_t steps) override {
            Menu_Entry_Type_Delegate::u_increase(steps);
        }

        void u_decrease(uint16_t steps) override {
            Menu_Entry_Type_Delegate::u_decrease(steps);
        }

        bool s_entered() override {
            return Menu_Entry_Type_Delegate::s_entered();
        }

        bool u_leave() override {
            return Menu_Entry_Type_Delegate::u_leave();
        }

        bool getValue() override {
            return Menu_Entry_Type_Delegate::getValue();
        }

        void p_setName(std::string name) override {
            m_name = name;
        }

    private:
        std::string m_name;
        bool m_checked;
    };

    } // floatpump
} // menu

#endif //FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H
